Index: palm/trunk/SOURCE/virtual_measurement_mod.f90
===================================================================
--- palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 3703)
+++ palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 3704)
@@ -867,13 +1300,13 @@
                     DO  mm = surf_def_h(0)%start_index(j,i),                   &
                              surf_def_h(0)%end_index(j,i)
-                       vmea(l)%measured_vars(n,m) = surf_def_h(0)%ts(mm)
+                       vmea(l)%measured_vars(m,n) = surf_def_h(0)%ts(mm)
                     ENDDO
                     DO  mm = surf_lsm_h%start_index(j,i),                      &
                              surf_lsm_h%end_index(j,i)
-                       vmea(l)%measured_vars(n,m) = surf_lsm_h%ts(mm)
+                       vmea(l)%measured_vars(m,n) = surf_lsm_h%ts(mm)
                     ENDDO
                     DO  mm = surf_usm_h%start_index(j,i),                      &
                              surf_usm_h%end_index(j,i)
-                       vmea(l)%measured_vars(n,m) = surf_usm_h%ts(mm)
+                       vmea(l)%measured_vars(m,n) = surf_usm_h%ts(mm)
                     ENDDO
                  ENDDO
@@ -891,13 +1324,13 @@
                     DO  mm = surf_def_h(0)%start_index(j,i),                   &
                              surf_def_h(0)%end_index(j,i)
-                       vmea(l)%measured_vars(n,m) = surf_def_h(0)%qsws(mm)
+                       vmea(l)%measured_vars(m,n) = surf_def_h(0)%qsws(mm)
                     ENDDO
                     DO  mm = surf_lsm_h%start_index(j,i),                      &
                              surf_lsm_h%end_index(j,i)
-                       vmea(l)%measured_vars(n,m) = surf_lsm_h%qsws(mm)
+                       vmea(l)%measured_vars(m,n) = surf_lsm_h%qsws(mm)
                     ENDDO
                     DO  mm = surf_usm_h%start_index(j,i),                      &
                              surf_usm_h%end_index(j,i)
-                       vmea(l)%measured_vars(n,m) = surf_usm_h%qsws(mm)
+                       vmea(l)%measured_vars(m,n) = surf_usm_h%qsws(mm)
                     ENDDO
                  ENDDO
@@ -915,13 +1348,13 @@
                     DO  mm = surf_def_h(0)%start_index(j,i),                   &
                              surf_def_h(0)%end_index(j,i)
-                       vmea(l)%measured_vars(n,m) = surf_def_h(0)%shf(mm)
+                       vmea(l)%measured_vars(m,n) = surf_def_h(0)%shf(mm)
                     ENDDO
                     DO  mm = surf_lsm_h%start_index(j,i),                      &
                              surf_lsm_h%end_index(j,i)
-                       vmea(l)%measured_vars(n,m) = surf_lsm_h%shf(mm)
+                       vmea(l)%measured_vars(m,n) = surf_lsm_h%shf(mm)
                     ENDDO
                     DO  mm = surf_usm_h%start_index(j,i),                      &
                              surf_usm_h%end_index(j,i)
-                       vmea(l)%measured_vars(n,m) = surf_usm_h%shf(mm)
+                       vmea(l)%measured_vars(m,n) = surf_usm_h%shf(mm)
                     ENDDO
                  ENDDO
@@ -940,14 +1373,14 @@
                        DO  mm = surf_lsm_h%start_index(j,i),                   &
                                 surf_lsm_h%end_index(j,i)
-                          vmea(l)%measured_vars(n,m) = surf_lsm_h%rad_net(mm)
+                          vmea(l)%measured_vars(m,n) = surf_lsm_h%rad_net(mm)
                        ENDDO
                        DO  mm = surf_usm_h%start_index(j,i),                   &
                                 surf_usm_h%end_index(j,i)
-                          vmea(l)%measured_vars(n,m) = surf_usm_h%rad_net(mm)
+                          vmea(l)%measured_vars(m,n) = surf_usm_h%rad_net(mm)
                        ENDDO
                     ENDDO
                  ENDIF
                  
-              CASE ( 'rsus', 'rsu' )
+              CASE ( 'rsus' )
                  IF ( radiation )  THEN
                     DO  m = 1, vmea(l)%ns
@@ -962,14 +1395,14 @@
                        DO  mm = surf_lsm_h%start_index(j,i),                   &
                                 surf_lsm_h%end_index(j,i)
-                          vmea(l)%measured_vars(n,m) = surf_lsm_h%rad_sw_out(mm)
+                          vmea(l)%measured_vars(m,n) = surf_lsm_h%rad_sw_out(mm)
                        ENDDO
                        DO  mm = surf_usm_h%start_index(j,i),                   &
                                 surf_usm_h%end_index(j,i)
-                          vmea(l)%measured_vars(n,m) = surf_usm_h%rad_sw_out(mm)
+                          vmea(l)%measured_vars(m,n) = surf_usm_h%rad_sw_out(mm)
                        ENDDO
                     ENDDO
                  ENDIF
                  
-              CASE ( 'rsds', 'rsd' )
+              CASE ( 'rsds' )
                  IF ( radiation )  THEN
                     DO  m = 1, vmea(l)%ns
@@ -984,14 +1417,14 @@
                        DO  mm = surf_lsm_h%start_index(j,i),                   &
                                 surf_lsm_h%end_index(j,i)
-                          vmea(l)%measured_vars(n,m) = surf_lsm_h%rad_sw_in(mm)
+                          vmea(l)%measured_vars(m,n) = surf_lsm_h%rad_sw_in(mm)
                        ENDDO
                        DO  mm = surf_usm_h%start_index(j,i),                   &
                                 surf_usm_h%end_index(j,i)
-                          vmea(l)%measured_vars(n,m) = surf_usm_h%rad_sw_in(mm)
+                          vmea(l)%measured_vars(m,n) = surf_usm_h%rad_sw_in(mm)
                        ENDDO
                     ENDDO
                  ENDIF
                  
-              CASE ( 'rlus', 'rlu' )
+              CASE ( 'rlus' )
                  IF ( radiation )  THEN
                     DO  m = 1, vmea(l)%ns
@@ -1006,14 +1439,14 @@
                        DO  mm = surf_lsm_h%start_index(j,i),                   &
                                 surf_lsm_h%end_index(j,i)
-                          vmea(l)%measured_vars(n,m) = surf_lsm_h%rad_lw_out(mm)
+                          vmea(l)%measured_vars(m,n) = surf_lsm_h%rad_lw_out(mm)
                        ENDDO
                        DO  mm = surf_usm_h%start_index(j,i),                   &
                                 surf_usm_h%end_index(j,i)
-                          vmea(l)%measured_vars(n,m) = surf_usm_h%rad_lw_out(mm)
+                          vmea(l)%measured_vars(m,n) = surf_usm_h%rad_lw_out(mm)
                        ENDDO
                     ENDDO
                  ENDIF
                  
-              CASE ( 'rlds', 'rld' )
+              CASE ( 'rlds' )
                  IF ( radiation )  THEN
                     DO  m = 1, vmea(l)%ns
@@ -1028,15 +1461,111 @@
                        DO  mm = surf_lsm_h%start_index(j,i),                   &
                                 surf_lsm_h%end_index(j,i)
-                          vmea(l)%measured_vars(n,m) = surf_lsm_h%rad_lw_in(mm)
+                          vmea(l)%measured_vars(m,n) = surf_lsm_h%rad_lw_in(mm)
                        ENDDO
                        DO  mm = surf_usm_h%start_index(j,i),                   &
                                 surf_usm_h%end_index(j,i)
-                          vmea(l)%measured_vars(n,m) = surf_usm_h%rad_lw_in(mm)
+                          vmea(l)%measured_vars(m,n) = surf_usm_h%rad_lw_in(mm)
                        ENDDO
                     ENDDO
                  ENDIF
+                 
+              CASE ( 'rsd' )
+                 IF ( radiation )  THEN
+                    DO  m = 1, vmea(l)%ns
+                       k = MERGE( 0, vmea(l)%k(m), radiation_scheme /= 'rrtmg' ) 
+                       j = vmea(l)%j(m)
+                       i = vmea(l)%i(m)
+                    
+                       vmea(l)%measured_vars(m,n) = rad_sw_in(k,j,i)
+                    ENDDO
+                 ENDIF
+                 
+              CASE ( 'rsu' )
+                 IF ( radiation )  THEN
+                    DO  m = 1, vmea(l)%ns
+                       k = MERGE( 0, vmea(l)%k(m), radiation_scheme /= 'rrtmg' ) 
+                       j = vmea(l)%j(m)
+                       i = vmea(l)%i(m)
+                    
+                       vmea(l)%measured_vars(m,n) = rad_sw_out(k,j,i)
+                    ENDDO
+                 ENDIF
+                 
+              CASE ( 'rlu' )
+                 IF ( radiation )  THEN
+                    DO  m = 1, vmea(l)%ns
+                       k = MERGE( 0, vmea(l)%k(m), radiation_scheme /= 'rrtmg' ) 
+                       j = vmea(l)%j(m)
+                       i = vmea(l)%i(m)
+                    
+                       vmea(l)%measured_vars(m,n) = rad_lw_out(k,j,i)
+                    ENDDO
+                 ENDIF
+                 
+              CASE ( 'rld' )
+                 IF ( radiation )  THEN
+                    DO  m = 1, vmea(l)%ns
+                       k = MERGE( 0, vmea(l)%k(m), radiation_scheme /= 'rrtmg' ) 
+                       j = vmea(l)%j(m)
+                       i = vmea(l)%i(m)
+                    
+                       vmea(l)%measured_vars(m,n) = rad_lw_in(k,j,i)
+                    ENDDO
+                 ENDIF
+                 
+              CASE ( 'rsddif' )
+                 IF ( radiation )  THEN
+                    DO  m = 1, vmea(l)%ns
+                       j = vmea(l)%j(m)
+                       i = vmea(l)%i(m)
+                    
+                       vmea(l)%measured_vars(m,n) = rad_sw_in_diff(j,i)
+                    ENDDO
+                 ENDIF
+                 
+              CASE ( 't_soil' )
+                 DO  m = 1, vmea(l)%ns_soil
+                    i = vmea(l)%i_soil(m)
+                    j = vmea(l)%j_soil(m)
+                    k = vmea(l)%k_soil(m)
+                    
+                    match_lsm = surf_lsm_h%start_index(j,i) <=                 &
+                                surf_lsm_h%end_index(j,i)
+                    match_usm = surf_usm_h%start_index(j,i) <=                 &
+                                surf_usm_h%end_index(j,i)
+                                
+                    IF ( match_lsm )  THEN
+                       mm = surf_lsm_h%start_index(j,i)
+                       vmea(l)%measured_vars_soil(m,n) = t_soil_h%var_2d(k,mm)
+                    ENDIF
+                    
+                    IF ( match_usm )  THEN
+                       mm = surf_usm_h%start_index(j,i)
+                       vmea(l)%measured_vars_soil(m,n) = t_wall_h(k,mm)
+                    ENDIF
+                 ENDDO
+                 
+              CASE ( 'm_soil' )
+                 DO  m = 1, vmea(l)%ns_soil
+                    i = vmea(l)%i_soil(m)
+                    j = vmea(l)%j_soil(m)
+                    k = vmea(l)%k_soil(m)
+                    
+                    match_lsm = surf_lsm_h%start_index(j,i) <=                 &
+                                surf_lsm_h%end_index(j,i)
+                                
+                    IF ( match_lsm )  THEN
+                       mm = surf_lsm_h%start_index(j,i)
+                       vmea(l)%measured_vars_soil(m,n) = m_soil_h%var_2d(k,mm)
+                    ENDIF
+                    
+                 ENDDO
 !
 !--           More will follow ...
-                 
+
+!
+!--           No match found - just set a fill value
+              CASE DEFAULT
+                 vmea(l)%measured_vars(:,n) = vmea(l)%fillout
            END SELECT
 
@@ -1044,5 +1573,5 @@
 
      ENDDO
-     
+          
   END SUBROUTINE vm_sampling
  
